#load "nums.cma"
module True_big_int = struct  
	open Big_int
	type t = big_int
	let zero = zero_big_int
	let unit = unit_big_int
	let compare = compare_big_int
	let add = add_big_int
	let mult = mult_big_int
	let succ = succ_big_int
	let string_of = string_of_big_int
	let length t = String.length (string_of_big_int t)
end

module Int = struct
	type t = int
	let zero = 0
	let unit = 1
	let compare = compare
	let add = (+)
	let mult = ( * )
	let succ = succ
	let string_of = string_of_int
	let length t = String.length (string_of_int t)
end

module Log = struct
	type t = float
	let zero = 0.	
	let unit = 1.	(* log scale *)
	let compare = compare
	let add = (+)
	let mult = ( * )
	let succ = succ
	let string_of = string_of_int
	let length t = String.length (string_of_int t)
end


(* A for Arithmetics *)
module A = True_big_int
type i = A.t
type hamming = i*i*i*i
let comp_hamming (a,_,_,_) (b,_,_,_) = A.compare a b

module S = Set.Make (struct type t = hamming let compare = comp_hamming end)

let s = ref (S.singleton (A.unit,A.zero,A.zero,A.zero))
let deux = A.add A.unit A.unit
let trois = A.add A.unit deux
let cinq = A.add deux trois

let push (value,v2,v3,v5) =
	s := List.fold_left
		(fun set e -> if not (S.mem e set) then S.add e set else set)
		!s
		[
			A.mult deux  value,A.succ v2,v3,v5;
			A.mult trois value,v2,A.succ v3,v5;
			A.mult cinq  value,v2,v3,A.succ v5;
		]

let () =
for i=1 to 1237 do
(* for i=1 to 10_000 do *)
	let (v,_,_,_) as a = S.min_elt !s in
	s := S.remove a !s;
	push a;
(* 	Printf.printf "%5i %s\n%!" i (A.string_of v); *)
	Printf.printf "%5i %i\n%!" i (A.length v);
(* 	if v < 0 then( Printf.printf "\n%i for i=%i\n" v i; exit 1) *)
done
