(*
The only trick is that, given the three dimension a b c,
one can reorder them like b c a or c a b but not like a c b, c b a or b a c,
before doing the pointwise comparison.

Once the comparison function is written,
just sort the array and check it is sorted.
*)

let scanf format = Scanf.bscanf Scanf.Scanning.stdib format
(* let id x = x *)
let nb_boxes = ref (-1)
let compare_boxes (a1,b1,c1) (a2,b2,c2) =
	if   a1 < a2 && b1 < b2 && c1 < c2
		|| b1 < a2 && c1 < b2 && a1 < c2
		|| c1 < a2 && a1 < b2 && b1 < c2
	then -1
	else if
		   a1 = a2 && b1 = b2 && c1 = c2
		|| b1 = a2 && c1 = b2 && a1 = c2
		|| c1 = a2 && a1 = b2 && b1 = c2
	then 0
	else 1
;;

scanf "%i\n" (fun i -> nb_boxes := i);
while !nb_boxes != 0 do
	let boxes = Array.init !nb_boxes (fun _ -> scanf "%i %i %i\n" (fun a b c -> a,b,c)) in
	Array.sort compare_boxes boxes;
	( try
			for i=0 to Array.length boxes -2 do
				if compare_boxes boxes.(i) boxes.(i+1) >= 0 then raise Exit;
			done;
			Printf.printf "YES\n%!";
		with Exit -> Printf.printf "NO\n%!");
	scanf "%i\n" (fun i -> nb_boxes := i);
done;;
